.text

#include "config-h100.h"
#include "config.h"
#include "mcf5249.h"

_start:

 
 /* unknown init stuff from rockbox bootloader */
    move.l  #MBAR+1,%d0
    movec.l %d0,%mbar
        
    move.l  #MBAR2+1,%d0
    movec.l %d0,%mbar2

    lea     MBAR,%a0
    lea     MBAR2,%a1
        
    clr.l  (0x180,%a1)  /* PLLCR = 0 */

    /* 64K DMA-capable SRAM at 0x10000000
       DMA is enabled and has priority in both banks
       All types of accesses are allowed
       (We might want to restrict that to save power) */
       /* already set up by the AVR
    move.l  #0x10000e01,%d0
    movec.l %d0,%rambar1 */

    /* 32K Non-DMA SRAM at 0x10010000
       All types of accesses are allowed
       (We might want to restrict that to save power) */
       /* also already set up 
    move.l  #0x10010001,%d0
    movec.l %d0,%rambar0 */
#if 1
	//this is based on the rockbox code, but was fiddled around a lot
	//no idea what's required to make it work, just that this works.
    /* Chip select 0 - Flash ROM */
    //try to keep it similar to the original settings
    moveq.l #0x00,%d0      /* CSAR0 - Base = 0x00000000 */
    move.l  %d0,(0x080,%a0)

    //flash size is 0x200000... 
    //old value is '0x001f0001' = 0x0000 0000 0001 1111 0000 0000 0000 0001
    //5 address bits masked...
    move.l  #FLASH_SIZE-0x10000+1,%d0 /* CSMR0 - All access */
    //setting CSMR0 here causes things to go somewhat weird
    move.l  %d0,(0x084,%a0)

//    move.l  #0x00000180,%d0 /* CSCR0 - no wait states, 16 bits, no bursts */
    move.l #0x00003d80, %d0 
//    move.l  %d0,(0x088,%a0)
#endif
    move.l #0x10010000,%sp /* stack at the end of 2nd RAM */

    jmp start_main

